<?php
/**
*
* @author Two Sheds twosheds@twosheds.com
*
* @package privmsgs
* @version $Id:1.6.0
* @copyright (c) 2009 TwoSheds
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'PRIVMSGS_MOD';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'acp_privmsgs_mod_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
$language_file = 'mods/info_acp_privmsgs_mod';

/*
* Options to display to the user (this is purely optional, if you do not need the options you do not have to set up this variable at all)
* Uses the acp_board style of outputting information, with some extras (such as the 'default' and 'select_user' options)
*/
// $options = array(
//	'test_username'	=> array('lang' => 'TEST_USERNAME', 'type' => 'text:40:255', 'explain' => true, 'default' => $user->data['username'], 'select_user' => true),
//	'test_boolean'	=> array('lang' => 'TEST_BOOLEAN', 'type' => 'radio:yes_no', 'default' => true),
// );

/*
* Optionally we may specify our own logo image to show in the upper corner instead of the default logo.
* $phpbb_root_path will get prepended to the path specified
* Image height should be 50px to prevent cut-off or stretching.
*/
$logo_img = 'install/privmsgs_mod.png';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(

	// Version 1.5.6
	'1.5.6'	=> array(
	),
	
	// Version 1.5.5
	'1.5.5'	=> array(
	),
	
	// Version 1.5.4
	'1.5.4'	=> array(
		//  Delete any existing acp definitions for this plugin
		'custom' => 'delete_all_acp_definitions',
		
		//  Add custom permission for this module
		'permission_add' => array(
			array('a_privmsgs', true),
		),
		
		// Add the module definitions to the ACP
		'module_add' => array(
			// First, lets add a new tab to the ACP
			array('acp', 0, 'ACP_PRIVMSGS_MOD_TAB'),

			// Next, lets add a new category under that tab
			array('acp', 'ACP_PRIVMSGS_MOD_TAB', 'ACP_PRIVMSGS_MOD_PAGETITLE'),

			// Now we will add the settings and features modes for the plugin using the "automatic" method.
			array('acp', 'ACP_PRIVMSGS_MOD_PAGETITLE', array(
					'module_basename'		=> 'privmsgs_mod',
					'modes'					=> array('moderate', 'configure')
				)
			)
		)
	),

	// Version 1.5.3
	'1.5.3'	=> array(
	),

	// Version 1.5.2
	'1.5.2'	=> array(
	),

	// Version 1.5.1
	'1.5.1'	=> array(
		// Rename three config variables, if they have been set by the user
		'custom' => 'rename_config_variables',
	),

	// Version 1.5.0
	'1.5.0'	=> array(),
	
	// Version 1.4.2
	'1.4.2'	=> array(),
	
	// Version 1.4.1
	'1.4.1'	=> array(),
	
	// Version 1.4.0
	'1.4.0'	=> array(),
	
	// Version 1.3.0
	'1.3.0'	=> array(
		//  Delete any existing acp definitions for this plugin
		'custom' => 'delete_all_acp_definitions',
		
		// Add the module definitions to the ACP
		'module_add' => array(
			// First, lets add a new tab to the ACP
			array('acp', 0, 'ACP_PRIVMSGS_MOD_TAB'),

			// Next, lets add a new category under that tab
			array('acp', 'ACP_PRIVMSGS_MOD_TAB', 'ACP_PRIVMSGS_MOD_PAGETITLE'),

			// Now we will add the settings and features modes for the plugin using the "automatic" method.
			array('acp', 'ACP_PRIVMSGS_MOD_PAGETITLE', array(
					'module_basename'		=> 'privmsgs_mod',
					'modes'					=> array('moderate', 'configure')
				)
			)
		)
	)
);

// Include the UMIL Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

// Clear the cache
cache_purge('', 0);
cache_purge('template', 0);

/*
* Delete any existing acp module definitions for our plugin
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function delete_all_acp_definitions($action, $version)
{
	global $db, $table_prefix, $umil;

	$sql = 'DELETE FROM ' . MODULES_TABLE . " WHERE module_langname LIKE 'ACP_PRIVMSGS_MOD%'";
	$result = $db->sql_query($sql);

	return 'ACP_PRIVMSGS_MOD_REMOVED_DEFINITIONS';
}

/*
* Rename three config variables, if they have been set by the user
*
* @param string $action The action (install|update|uninstall) will be sent through this.
* @param string $version The version this is being run for will be sent through this.
*/
function rename_config_variables($action, $version)
{
	global $db, $table_prefix, $umil;
	
	//  Rename three config variables, per the phpBB reviewers
	if ($action !== 'uninstall')
	{
		if ($umil->config_exists('ACP_PRIVMSGS_MOD_per_page'))
		{
			$sql = 'UPDATE ' . CONFIG_TABLE . " SET config_name='acp_privmsgs_mod_per_page' WHERE config_name = 'ACP_PRIVMSGS_MOD_per_page'";
			$result = $db->sql_query($sql);
		}
	
		if ($umil->config_exists('ACP_PRIVMSGS_MOD_show_txt'))
		{
			$sql = 'UPDATE ' . CONFIG_TABLE . " SET config_name='acp_privmsgs_mod_show_txt' WHERE config_name = 'ACP_PRIVMSGS_MOD_show_txt'";
			$result = $db->sql_query($sql);
		}
	
		if ($umil->config_exists('ACP_PRIVMSGS_MOD_filter'))
		{
			$sql = 'UPDATE ' . CONFIG_TABLE . " SET config_name='acp_privmsgs_mod_filter' WHERE config_name = 'ACP_PRIVMSGS_MOD_filter'";
			$result = $db->sql_query($sql);
		}
	}

	//  Change the values of the show_txt config variable, using set_config per phpBB reviewers
	if ($umil->config_exists('acp_privmsgs_mod_show_txt'))
	{	
		if ($config['acp_privmsgs_mod_show_txt'] == '1')
		{
			set_config('acp_privmsgs_mod_show_txt', 'y');
		} else {
			set_config('acp_privmsgs_mod_show_txt', 'n');
		}
	}		
	
	//  Remove a deprecated config variable
	if ($umil->config_exists('ACP_PRIVMSGS_MOD_show_wpm'))
	{
		$umil->config_remove('ACP_PRIVMSGS_MOD_show_wpm');
	}
	
	return 'ACP_PRIVMSGS_MOD_RENAMED_CONFIG_VARS';
}
?>
